/******************************** { ********************************/
//
//	޲	: AT90S2333/4433
//	̧ٖ	: BC.C
//	Ver.	: 1.0
//	e	: AT90S2333/4433^dr[d(۸)
//	߲	: IAR icca90
//		: Asmund Saetre / Terje Frostad / Dietmar Koenig
//		: 2000N 2 2-dr[dQl݌vvɕύX
//			  2000N 218-ŏIAJ
//
/*****************************************************************************/

#include "BC.H"

time_struct time;										// (b)S\

#ifdef DEBUG
extern int term_value1;									// I1lSϐ
extern int term_value2;									// I2lSϐ
extern int battery_volt_max;							// drdőlSϐ
extern int battery_volt_min;							// drdŏlSϐ
extern int temperature_max;								// drxőlSϐ
extern int temperature_min;								// drxŏlSϐ
extern int charge_volt_max;								// [ddőlSϐ
extern int charge_volt_min;								// [ddŏlSϐ
extern int charge_current_max;							// [ddőlSϐ
extern int charge_current_min;							// [ddŏlSϐ
#endif

void Setup(void)										/*  */
{														// ߰,PWM,UART,Ԏv̒`
	TCCR1A	= 0x81;										// /1 8ޯPWM񔽓]o͎w
	TIFR	= 0x80;										// /1 ް۰荞ݗv׸މ
	TIMSK	= 0x80;										// /1 ް۰荞݋
	TCNT1	= 0x00;										// /1
	TCCR1B	= 0x00;										// PWM~

	PORTC	= 0x00;										// ߰C͎w(A/D͗p)
	DDRC	= 0x00;										// ߰Cٱ߂Ȃݒ
	PORTB	= 0xFF;										// ߰Bo=Hw(LED)
	DDRB	= 0xFF;										// ߰Bo͐ݒ
	PORTD	= 0xFF;										// ߰Dٱߐݒ

	ADCSR	= 0x96;										// A/Dϊ 64Ou,Pƕϊw

#ifdef DEBUG
	Inituart(3);										// UART 115200bps(7.3728MHz)
//	inituart(23);										// UART 19200(7.3728MHz)
#endif

	CHARGE_STATUS	= 0x00;								// [d׸ޏ
	time.sec		= 0;								// bϐ
	time.min		= 0;								// ϐ
	time.hour		= 0;								// ϐ
	time.t_count	= 14456;							// 1bvl(7.3728MHz/510=14.456kHz(PWMg))
	_SEI();												// S荞݋
}

void Stop_PWM(void)										/* PWM~(OFF) */
{
	if ((TERMINATION == 0x00) && (TCCR1B & (1<<CS10)) && (OCR1 != 0))
	{													/* I,PWM쒆 */
		if (OCR1 == 1)									/* rl=1 */
		{
			while(TCNT1 > 2);							// PWM2=Lԑҋ@
			while(TCNT1 < 2);							// PWM2=Hԑҋ@
		}
		else											/* rl>1 */
		{
			while(TCNT1 > OCR1);						// PWM2=Lԑҋ@
			while(OCR1 > TCNT1);						// PWM2=Hԑҋ@
		}
		TCCR1B = 0x00;									// PWM~(PWM2=L)
	}
}

void Stable_ADC(void)									/* A/Dϊl܂őҋ@ */
{
	int V[4];											// O3A/DϊlۑǏϐ
	char i;												// /ʒuǏϐ
	int Vmax, Vmin;										// ől,ŏlǏϐ

	for (Vmax=10,Vmin=0;Vmax > (Vmin+1);)				/* A/Dϊl(Vmax(Vmin+1))܂Ōpҋ@ */
	{
		V[3] = V[2];									// 3Ol3Oۑϐֈړ
		V[2] = V[1];									// 2Ol2Oۑϐֈړ
		V[1] = V[0];									// Ol1Oۑϐֈړ
		ADCSR |= 0x40;									// A/DϊJn
		while (!(ADCSR & (1<<ADIF)));					// A/Dϊҋ@
		V[0] = ADC;										// l擾/ۑ
		Vmin = V[0];									// lŏlƂĉݒ
		Vmax = V[0];									// lőlƂĉݒ
		for (i=0;i<=3;i++)								/* ŏl/ől擾 */
		{ 
			if (V[i] > Vmax)							// Ήl傫΁A
				Vmax=V[i];								// őlXV
			if (V[i] < Vmin)							// Ήl΁A
				Vmin=V[i];								// ŏlXV
		}
	}
}

int Battery(unsigned char value)						/* Ήl擾 */
{
	char i;												// ̎񐔋Ǐϐ
	int av;												// ϒlǏϐ

	switch (value)
	{
		case VOLTAGE_WITH_PWM_TURNOFF:					/* drd */
			Stop_PWM();									// PWM~
			ADMUX = VBAT2;								// drd(A/Dϊ)w
			Stable_ADC();								// A/DϊlԊmF
			break;
		case TEMPERATURE:								/* drx */
			Stop_PWM();									// PWM~
			ADMUX = TBAT2;								// drx(A/Dϊ)w
			Stable_ADC();								// A/DϊlԊmF
			break;
		case VOLTAGE:									/* [dd */
			ADMUX = VBAT2;								// [dd(A/Dϊ)w
			break;
		case CURRENT:									/* [dd */
			ADMUX = IBAT2;								// [dd(A/Dϊ)w
			break;
	}

														/* 8̎ŕϒl擾 */
	for(av=0,i=8;i;--i)									/* 8̎ώZ */
	{
		ADCSR |= 0x40;									// A/DϊJn
		while (!(ADCSR & (1<<ADIF)));					// A/Dϊҋ@
		av = av+ADC;									// lώZ
	}
	av = av/8;											// 8񕪂̕ϒl擾

	TCCR1B = 0x01;										// PWMĊJ
	CLRBIT(ADCSR,ADIF);									// A/Dϊ荞ݗv׸މ

	switch (value)										/* ޯޗpeŏ/őlXV */
	{
		case VOLTAGE_WITH_PWM_TURNOFF:					/* drdŏ/őlXV */
			if(av <= battery_volt_min)					// lŏlȂA
				battery_volt_min = av;					// ŏlXV
			if (av > battery_volt_max)					// lőlȂA
				battery_volt_max = av;					// őlXV
			break;
		case TEMPERATURE:								/* drxŏ/őlXV */
			if (av <= temperature_min)					// lŏlȂA
				temperature_min = av;					// ŏlXV
			if(av > temperature_max)					// lőlȂA
				temperature_max = av;					// őlXV
			break; 
		case VOLTAGE:									/* [ddŏ/őlXV */
			if (av <= charge_volt_min)					// lŏlȂA
				charge_volt_min = av;					// ŏlXV
			if (av > charge_volt_max)					// lőlȂA
				charge_volt_max = av;					// őlXV
			break;
		case CURRENT:									/* [ddŏ/őlXV */
			break;										// ()[dd͏[dŎs
	}
	return(av);											// ϒlƋɕA
}

void C_task main(void)									/* 又 */
{
	Setup();											// S̏
	Send_CR_LF();										// AsUARTM
	for (;;)											// ȍ~JԂ
	{													// ()SW0ɂ[dJn
		SETBIT(CHARGE_STATUS,FAST);						// }[d׸ސݒ
		TERMINATION = 0x00;								// [dI׸ޏ(=0)

		SETBIT(PORTB,(LED0+LED1+LED2+LED3));			// LED0`3
		while ((PIND & (1<<PD4)));						// SW0܂őҋ@

		while (!(CHKBIT(CHARGE_STATUS,ERROR)))			/* ُȂAJԂ */
		{
			if ((CHKBIT(CHARGE_STATUS,FAST)) && (!(CHKBIT(CHARGE_STATUS,ERROR))))
			{											/* ُȂ}[d */
				SETBIT(PORTB,(LED0+LED1+LED2+LED3));	// LED0`3
				CLRBIT(PORTB,(LED0));					// LED0̂ݓ_(}[d\)
				TERMINATION = 0x00;						// [dI׸ޏ
				CHARGE_STATUS = 0x00;					// [d׸ޏ
				FAST_charge();							// }[ds
				#ifdef DEBUG 
					Send_state_change();				// ԏUARTM
					Send_CR_LF();						// AsUARTM
				#endif
			}
			if ((CHKBIT(CHARGE_STATUS,TRICKLE)) && (!(CHKBIT(CHARGE_STATUS,ERROR))))
			{											/* ُȂظُ[dԎ */
				SETBIT(PORTB,(LED0+LED1+LED2+LED3));	// LED0`3
				CLRBIT(PORTB,(LED1));					// LED1()̂ݓ_(ظُ[d\)
				TERMINATION = 0x00;						// [dI׸ޏ
				CHARGE_STATUS = 0x00;					// [d׸ޏ
				TRICKLE_charge();						// ظُ[ds
				FAST_charge();							// }[ds
				#ifdef DEBUG 
					Send_state_change();				// ԏUARTM
					Send_CR_LF();						// AsUARTM
				#endif
			}
		}

		if (CHKBIT(CHARGE_STATUS,ERROR))				/* ُ픭 */
		{
			SETBIT(PORTB,(LED0+LED1+LED2+LED3));		// LED0`3
			CLRBIT(PORTB,LED3);							// LED3(װ)̂ݓ_
			for(;;);									// ҋ@
		}
	}
}

void interrupt[TIMER1_OVF_vect] T1Ovf(void)				/* /1 ް۰荞 */
{
	if (0x0000 == --time.t_count)						/* 1boߎ */
	{
		#ifdef DEBUG
			if (!(time.sec % 10))						/* 10bԊuŏԏ񑗐M */
			{
				Send_charge_state();					// ԏUARTM
				Send_CR_LF();							// AsUARTM
			}
		#endif
		if ( 60 == ++time.sec )							/* 60b(1)oߎ */
		{
			if ( 60 == ++time.min )						/* 60(1)oߎ */
			{
				if ( 24 == ++time.hour )				/* 24(1)oߎ */
				{
					time.hour = 0x00;					// 24Ԍo߂Ŏԕϐ(=0)
				}
				time.min = 0x00;						// 60(1)o߂ŕϐ(=0)
			}
			time.sec = 0x00;							// 60b(1)o߂ŕbϐ(=0)
			if ((CHKBIT(CHARGE_STATUS,TRICKLE)) && (!(CHKBIT(CHARGE_STATUS,ERROR))))
			{											/* ُȂظُ[dԁA2bLED1()_ */
				if (time.sec % 2)						// bŁA
					CLRBIT(PORTB,(LED1));				// LED1()_
				else									// bŁA
					SETBIT(PORTB,(LED1));				// LED1()
			}
		}
		time.t_count = 14456;							// 1bo߂1bvl(7.3728MHz/510=14.456kHz(PWMg))
	}
}

/*
void interrupt[TIMER1_CAPT1_vect] T1Capt(void)			// /1 ߊl荞({pŖgp)
{
}

void interrupt[TIMER1_COMP_vect] T1Comp(void)			// /1 rv荞({pŖgp)
{
}

void interrupt[TIMER0_OVF_vect] T0Ovf(void)				// /0 ް۰荞({pŖgp)
{
}

void interrupt[SPI_STC_vect] SPITranceiveComplete(void)	// SPI]荞({pŖgp)
{
}

void interrupt[UART_RX_vect] UARTReceive(void)			// UARTM荞({pŖgp)
{
}

void interrupt[UART_UDRE_vect] UARTDregEmpty(void)		// UARTް ڼ޽󂫊荞({pŖgp)
{
}

void interrupt[UART_TX_vect] UARTTransmit(void)			// UARTM荞({pŖgp)
{
}

void interrupt[ADC_vect] ADCConvert(void)				// A/Dϊ荞({pŖgp)
{
}

void interrupt[EE_RDY_vect] EEPROMReady(void)			// EEPROM荞({pŖgp)
{
}

void interrupt[ANA_COMP_vect] ACOMP(void)				// ۸ޔr튄荞({pŖgp)
{
}
*/
// ************************[ End of BC.C ]*******************************
